# Certificate

TLS/SSL certificates are used to secure network communications and prove the identity of websites on the Internet and resources on private networks. The certificates and their associated private keys are provided in PEM (Privacy Enhanced Mail) format.

This tag groups all operations for certificate.

## Retrieve all Certificate

> This endpoint enables retrieving all Certificate using\
> pagination and optional filters.<br>

```json
{"openapi":"3.0.3","info":{"title":"Certificate Manager Service API","version":"2.0"},"tags":[{"name":"Certificate","description":"TLS/SSL certificates are used to secure network communications and prove\nthe identity of websites on the Internet and resources on private networks. The certificates and their associated\nprivate keys are provided in PEM (Privacy Enhanced Mail) format.\n\nThis tag groups all operations for certificate.\n"}],"servers":[{"url":"https://certificate-manager.de-fra.ionos.com","description":"Frankfurt"}],"security":[{"tokenAuth":[]}],"components":{"securitySchemes":{"tokenAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT","description":"The token can be generated using the \n[Authentication API](https://api.ionos.com/docs/authentication/v1/#tag/tokens/operation/tokensGenerate).\n"}},"parameters":{"paginationOffset":{"name":"offset","in":"query","description":"The first element (of the total list of elements) to include in the response. Use together with limit for pagination.","required":false,"schema":{"type":"integer","format":"int32","default":0,"minimum":0}},"paginationLimit":{"name":"limit","in":"query","description":"The maximum number of elements to return. Use together with offset for pagination.","required":false,"schema":{"type":"integer","format":"int32","default":100,"minimum":1,"maximum":1000}},"commonNameFilter":{"name":"filter.commonName","in":"query","description":"Filter by the common name (DNS).\n","required":false,"schema":{"type":"string"}},"autoCertificateFilter":{"name":"filter.autoCertificate","in":"query","description":"Filter by autoCertificateID.\n","required":false,"schema":{"type":"string","format":"uuid"}}},"schemas":{"CertificateReadList":{"allOf":[{"type":"object","required":["id","type","href"],"properties":{"id":{"description":"ID of the list of Certificate resources.","type":"string","format":"uuid"},"type":{"description":"The type of the resource.","type":"string","enum":["collection"]},"href":{"description":"The URL of the list of Certificate resources.","type":"string"},"items":{"description":"The list of Certificate resources.","type":"array","items":{"$ref":"#/components/schemas/CertificateRead"}}}},{"$ref":"#/components/schemas/Pagination"}]},"CertificateRead":{"type":"object","required":["id","type","href","metadata","properties"],"properties":{"id":{"type":"string","description":"The ID (UUID) of the Certificate.","format":"uuid"},"type":{"description":"The type of the resource.","type":"string","enum":["certificate"]},"href":{"description":"The URL of the Certificate.","type":"string"},"metadata":{"$ref":"#/components/schemas/MetadataWithCertificateInformation"},"properties":{"$ref":"#/components/schemas/Certificate"}}},"MetadataWithCertificateInformation":{"allOf":[{"$ref":"#/components/schemas/MetadataWithStatus"},{"type":"object","required":["expired","notBefore","notAfter","serialNumber","commonName","subjectAlternativeNames"],"properties":{"autoCertificate":{"type":"string","format":"uuid","description":"The ID of the auto-certificate that caused issuing of the certificate."},"lastIssuedCertificate":{"type":"string","format":"uuid","description":"The ID of the last issued certificate that belongs to the same auto-certificate."},"expired":{"type":"boolean","description":"Indicates if the certificate is expired."},"notBefore":{"type":"string","format":"date-time","description":"The start date of the certificate."},"notAfter":{"type":"string","format":"date-time","description":"The end date of the certificate."},"serialNumber":{"type":"string","description":"The serial number of the certificate in hex."},"commonName":{"type":"string","description":"The common name (DNS) of the certificate."},"subjectAlternativeNames":{"type":"array","items":{"type":"string"},"description":"Optional additional names added to the issued certificate.\nThe additional names needs to be part of a zone in IONOS Cloud DNS.\n"}}}]},"MetadataWithStatus":{"readOnly":true,"allOf":[{"$ref":"#/components/schemas/Metadata"},{"type":"object","required":["state","message"],"properties":{"state":{"type":"string","description":"The resource state.","enum":["PROVISIONING","AVAILABLE","FAILED"]},"message":{"type":"string","description":"A human readable message describing the current state.\nIn case of an error, the message will contain a detailed error message.\n"}}}]},"Metadata":{"type":"object","description":"Metadata of the resource.","properties":{"createdDate":{"type":"string","format":"date-time","description":"The ISO 8601 creation timestamp.","readOnly":true},"createdBy":{"type":"string","description":"Unique name of the identity that created the resource.","readOnly":true},"createdByUserId":{"type":"string","description":"Unique id of the identity that created the resource.","readOnly":true},"lastModifiedDate":{"type":"string","format":"date-time","description":"The ISO 8601 modified timestamp.","readOnly":true},"lastModifiedBy":{"type":"string","description":"Unique name of the identity that last modified the resource.","readOnly":true},"lastModifiedByUserId":{"type":"string","description":"Unique id of the identity that last modified the resource.","readOnly":true},"resourceURN":{"type":"string","description":"Unique name of the resource.","readOnly":true}}},"Certificate":{"description":"TLS/SSL certificates are used to secure network communications and prove\nthe identity of websites on the Internet and resources on private networks. The certificates and their associated\nprivate keys are provided in PEM (Privacy Enhanced Mail) format.\n","type":"object","required":["name","certificate","certificateChain","privateKey"],"properties":{"name":{"type":"string","description":"The certificate name."},"certificate":{"type":"string","description":"The certificate body."},"certificateChain":{"type":"string","description":"The certificate chain."},"privateKey":{"type":"string","description":"The RSA private key is used for authentication and symmetric key exchange when establishing an SSL session. It is a part of the public key infrastructure generally used with SSL certificates.","writeOnly":true}}},"Pagination":{"required":["offset","limit","_links"],"description":"Pagination information. The offset and limit parameters are used to\nnavigate the list of elements. The _links object contains URLs to\nnavigate the different pages.\n","type":"object","properties":{"offset":{"$ref":"#/components/schemas/Offset"},"limit":{"$ref":"#/components/schemas/Limit"},"_links":{"$ref":"#/components/schemas/Links"}}},"Offset":{"description":"The offset specified in the request (if none was specified, the default\noffset is 0).\n","type":"integer","minimum":0,"readOnly":true},"Limit":{"description":"The limit specified in the request (if none was specified, use the\nendpoint's default pagination limit).\n","type":"integer","minimum":0,"readOnly":true},"Links":{"description":"URLs to navigate the different pages. As of now we always only return a\nsingle page.\n","type":"object","properties":{"prev":{"description":"URL (with offset and limit parameters) of the previous page; only\npresent if offset is greater than 0.\n","type":"string","format":"uri","readOnly":true},"self":{"description":"URL (with offset and limit parameters) of the current page.\n","type":"string","format":"uri","readOnly":true},"next":{"description":"URL (with offset and limit parameters) of the next page; only\npresent if offset + limit is less than the total number of elements.\n","type":"string","format":"uri","readOnly":true}}},"Error":{"description":"The Error object is used to represent an error response from the API.\n","type":"object","properties":{"httpStatus":{"type":"integer","description":"The HTTP status code of the operation."},"messages":{"type":"array","description":"A list of error messages.\n","items":{"type":"object","properties":{"errorCode":{"type":"string","description":"Application internal error code\n"},"message":{"type":"string","description":"A human readable explanation specific to this occurrence of the\nproblem.\n"}}}}}}},"responses":{"BadRequest":{"description":"### Bad Request\nThe request send to the API was malformed.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"Unauthorized":{"description":"### Unauthorized\nThe request is missing authorization information or the authorization information provided are expired.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"NotAllowed":{"description":"### Not Allowed\nThe user issuing the request does not have the needed permissions.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"TooManyRequests":{"description":"### Too Many Requests\nThe user has sent too many requests in a given amount of time.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"InternalError":{"description":"### Internal Server Error\nAn internal error occurred. We apologize for the inconvenience!\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"ServiceUnavailable":{"description":"### Service Unavailable\nThe server is currently unable to handle the request due to a temporary overloading or maintenance of the server.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"UnexpectedError":{"description":"### Unexpected Internal Server Error\nAn unexpected internal error occurred. We apologize for the inconvenience!\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}},"paths":{"/certificates":{"get":{"operationId":"certificatesGet","summary":"Retrieve all Certificate","description":"This endpoint enables retrieving all Certificate using\npagination and optional filters.\n","parameters":[{"$ref":"#/components/parameters/paginationOffset"},{"$ref":"#/components/parameters/paginationLimit"},{"$ref":"#/components/parameters/commonNameFilter"},{"$ref":"#/components/parameters/autoCertificateFilter"}],"tags":["Certificate"],"responses":{"200":{"description":"Returned all requested Certificate successfully.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/CertificateReadList"}}}},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/NotAllowed"},"429":{"$ref":"#/components/responses/TooManyRequests"},"500":{"$ref":"#/components/responses/InternalError"},"503":{"$ref":"#/components/responses/ServiceUnavailable"},"default":{"$ref":"#/components/responses/UnexpectedError"}}}}}}
```

## Create Certificate

> Creates a new Certificate.\
> \
> The full Certificate needs to be provided to create the object.\
> Optional data will be filled with defaults or left empty.<br>

```json
{"openapi":"3.0.3","info":{"title":"Certificate Manager Service API","version":"2.0"},"tags":[{"name":"Certificate","description":"TLS/SSL certificates are used to secure network communications and prove\nthe identity of websites on the Internet and resources on private networks. The certificates and their associated\nprivate keys are provided in PEM (Privacy Enhanced Mail) format.\n\nThis tag groups all operations for certificate.\n"}],"servers":[{"url":"https://certificate-manager.de-fra.ionos.com","description":"Frankfurt"}],"security":[{"tokenAuth":[]}],"components":{"securitySchemes":{"tokenAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT","description":"The token can be generated using the \n[Authentication API](https://api.ionos.com/docs/authentication/v1/#tag/tokens/operation/tokensGenerate).\n"}},"schemas":{"CertificateCreate":{"type":"object","required":["properties"],"properties":{"metadata":{"description":"Metadata","additionalProperties":true},"properties":{"$ref":"#/components/schemas/Certificate"}}},"Certificate":{"description":"TLS/SSL certificates are used to secure network communications and prove\nthe identity of websites on the Internet and resources on private networks. The certificates and their associated\nprivate keys are provided in PEM (Privacy Enhanced Mail) format.\n","type":"object","required":["name","certificate","certificateChain","privateKey"],"properties":{"name":{"type":"string","description":"The certificate name."},"certificate":{"type":"string","description":"The certificate body."},"certificateChain":{"type":"string","description":"The certificate chain."},"privateKey":{"type":"string","description":"The RSA private key is used for authentication and symmetric key exchange when establishing an SSL session. It is a part of the public key infrastructure generally used with SSL certificates.","writeOnly":true}}},"CertificateRead":{"type":"object","required":["id","type","href","metadata","properties"],"properties":{"id":{"type":"string","description":"The ID (UUID) of the Certificate.","format":"uuid"},"type":{"description":"The type of the resource.","type":"string","enum":["certificate"]},"href":{"description":"The URL of the Certificate.","type":"string"},"metadata":{"$ref":"#/components/schemas/MetadataWithCertificateInformation"},"properties":{"$ref":"#/components/schemas/Certificate"}}},"MetadataWithCertificateInformation":{"allOf":[{"$ref":"#/components/schemas/MetadataWithStatus"},{"type":"object","required":["expired","notBefore","notAfter","serialNumber","commonName","subjectAlternativeNames"],"properties":{"autoCertificate":{"type":"string","format":"uuid","description":"The ID of the auto-certificate that caused issuing of the certificate."},"lastIssuedCertificate":{"type":"string","format":"uuid","description":"The ID of the last issued certificate that belongs to the same auto-certificate."},"expired":{"type":"boolean","description":"Indicates if the certificate is expired."},"notBefore":{"type":"string","format":"date-time","description":"The start date of the certificate."},"notAfter":{"type":"string","format":"date-time","description":"The end date of the certificate."},"serialNumber":{"type":"string","description":"The serial number of the certificate in hex."},"commonName":{"type":"string","description":"The common name (DNS) of the certificate."},"subjectAlternativeNames":{"type":"array","items":{"type":"string"},"description":"Optional additional names added to the issued certificate.\nThe additional names needs to be part of a zone in IONOS Cloud DNS.\n"}}}]},"MetadataWithStatus":{"readOnly":true,"allOf":[{"$ref":"#/components/schemas/Metadata"},{"type":"object","required":["state","message"],"properties":{"state":{"type":"string","description":"The resource state.","enum":["PROVISIONING","AVAILABLE","FAILED"]},"message":{"type":"string","description":"A human readable message describing the current state.\nIn case of an error, the message will contain a detailed error message.\n"}}}]},"Metadata":{"type":"object","description":"Metadata of the resource.","properties":{"createdDate":{"type":"string","format":"date-time","description":"The ISO 8601 creation timestamp.","readOnly":true},"createdBy":{"type":"string","description":"Unique name of the identity that created the resource.","readOnly":true},"createdByUserId":{"type":"string","description":"Unique id of the identity that created the resource.","readOnly":true},"lastModifiedDate":{"type":"string","format":"date-time","description":"The ISO 8601 modified timestamp.","readOnly":true},"lastModifiedBy":{"type":"string","description":"Unique name of the identity that last modified the resource.","readOnly":true},"lastModifiedByUserId":{"type":"string","description":"Unique id of the identity that last modified the resource.","readOnly":true},"resourceURN":{"type":"string","description":"Unique name of the resource.","readOnly":true}}},"Error":{"description":"The Error object is used to represent an error response from the API.\n","type":"object","properties":{"httpStatus":{"type":"integer","description":"The HTTP status code of the operation."},"messages":{"type":"array","description":"A list of error messages.\n","items":{"type":"object","properties":{"errorCode":{"type":"string","description":"Application internal error code\n"},"message":{"type":"string","description":"A human readable explanation specific to this occurrence of the\nproblem.\n"}}}}}}},"responses":{"BadRequest":{"description":"### Bad Request\nThe request send to the API was malformed.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"Unauthorized":{"description":"### Unauthorized\nThe request is missing authorization information or the authorization information provided are expired.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"NotAllowed":{"description":"### Not Allowed\nThe user issuing the request does not have the needed permissions.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"UnsupportedMediaType":{"description":"### Unsupported Media Type\nThe request has an unsupported media type.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"UnprocessableEntity":{"description":"### Unprocessable Entity\nThe request was well-formed but was unable to be followed due to semantic errors.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"TooManyRequests":{"description":"### Too Many Requests\nThe user has sent too many requests in a given amount of time.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"InternalError":{"description":"### Internal Server Error\nAn internal error occurred. We apologize for the inconvenience!\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"ServiceUnavailable":{"description":"### Service Unavailable\nThe server is currently unable to handle the request due to a temporary overloading or maintenance of the server.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"UnexpectedError":{"description":"### Unexpected Internal Server Error\nAn unexpected internal error occurred. We apologize for the inconvenience!\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}},"paths":{"/certificates":{"post":{"operationId":"certificatesPost","summary":"Create Certificate","tags":["Certificate"],"description":"Creates a new Certificate.\n\nThe full Certificate needs to be provided to create the object.\nOptional data will be filled with defaults or left empty.\n","requestBody":{"description":"Certificate to create.","required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/CertificateCreate"}}}},"responses":{"201":{"description":"Certificate successfully created.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/CertificateRead"}}}},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/NotAllowed"},"415":{"$ref":"#/components/responses/UnsupportedMediaType"},"422":{"$ref":"#/components/responses/UnprocessableEntity"},"429":{"$ref":"#/components/responses/TooManyRequests"},"500":{"$ref":"#/components/responses/InternalError"},"503":{"$ref":"#/components/responses/ServiceUnavailable"},"default":{"$ref":"#/components/responses/UnexpectedError"}}}}}}
```

## Retrieve Certificate

> Returns the Certificate by ID.

```json
{"openapi":"3.0.3","info":{"title":"Certificate Manager Service API","version":"2.0"},"tags":[{"name":"Certificate","description":"TLS/SSL certificates are used to secure network communications and prove\nthe identity of websites on the Internet and resources on private networks. The certificates and their associated\nprivate keys are provided in PEM (Privacy Enhanced Mail) format.\n\nThis tag groups all operations for certificate.\n"}],"servers":[{"url":"https://certificate-manager.de-fra.ionos.com","description":"Frankfurt"}],"security":[{"tokenAuth":[]}],"components":{"securitySchemes":{"tokenAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT","description":"The token can be generated using the \n[Authentication API](https://api.ionos.com/docs/authentication/v1/#tag/tokens/operation/tokensGenerate).\n"}},"schemas":{"CertificateRead":{"type":"object","required":["id","type","href","metadata","properties"],"properties":{"id":{"type":"string","description":"The ID (UUID) of the Certificate.","format":"uuid"},"type":{"description":"The type of the resource.","type":"string","enum":["certificate"]},"href":{"description":"The URL of the Certificate.","type":"string"},"metadata":{"$ref":"#/components/schemas/MetadataWithCertificateInformation"},"properties":{"$ref":"#/components/schemas/Certificate"}}},"MetadataWithCertificateInformation":{"allOf":[{"$ref":"#/components/schemas/MetadataWithStatus"},{"type":"object","required":["expired","notBefore","notAfter","serialNumber","commonName","subjectAlternativeNames"],"properties":{"autoCertificate":{"type":"string","format":"uuid","description":"The ID of the auto-certificate that caused issuing of the certificate."},"lastIssuedCertificate":{"type":"string","format":"uuid","description":"The ID of the last issued certificate that belongs to the same auto-certificate."},"expired":{"type":"boolean","description":"Indicates if the certificate is expired."},"notBefore":{"type":"string","format":"date-time","description":"The start date of the certificate."},"notAfter":{"type":"string","format":"date-time","description":"The end date of the certificate."},"serialNumber":{"type":"string","description":"The serial number of the certificate in hex."},"commonName":{"type":"string","description":"The common name (DNS) of the certificate."},"subjectAlternativeNames":{"type":"array","items":{"type":"string"},"description":"Optional additional names added to the issued certificate.\nThe additional names needs to be part of a zone in IONOS Cloud DNS.\n"}}}]},"MetadataWithStatus":{"readOnly":true,"allOf":[{"$ref":"#/components/schemas/Metadata"},{"type":"object","required":["state","message"],"properties":{"state":{"type":"string","description":"The resource state.","enum":["PROVISIONING","AVAILABLE","FAILED"]},"message":{"type":"string","description":"A human readable message describing the current state.\nIn case of an error, the message will contain a detailed error message.\n"}}}]},"Metadata":{"type":"object","description":"Metadata of the resource.","properties":{"createdDate":{"type":"string","format":"date-time","description":"The ISO 8601 creation timestamp.","readOnly":true},"createdBy":{"type":"string","description":"Unique name of the identity that created the resource.","readOnly":true},"createdByUserId":{"type":"string","description":"Unique id of the identity that created the resource.","readOnly":true},"lastModifiedDate":{"type":"string","format":"date-time","description":"The ISO 8601 modified timestamp.","readOnly":true},"lastModifiedBy":{"type":"string","description":"Unique name of the identity that last modified the resource.","readOnly":true},"lastModifiedByUserId":{"type":"string","description":"Unique id of the identity that last modified the resource.","readOnly":true},"resourceURN":{"type":"string","description":"Unique name of the resource.","readOnly":true}}},"Certificate":{"description":"TLS/SSL certificates are used to secure network communications and prove\nthe identity of websites on the Internet and resources on private networks. The certificates and their associated\nprivate keys are provided in PEM (Privacy Enhanced Mail) format.\n","type":"object","required":["name","certificate","certificateChain","privateKey"],"properties":{"name":{"type":"string","description":"The certificate name."},"certificate":{"type":"string","description":"The certificate body."},"certificateChain":{"type":"string","description":"The certificate chain."},"privateKey":{"type":"string","description":"The RSA private key is used for authentication and symmetric key exchange when establishing an SSL session. It is a part of the public key infrastructure generally used with SSL certificates.","writeOnly":true}}},"Error":{"description":"The Error object is used to represent an error response from the API.\n","type":"object","properties":{"httpStatus":{"type":"integer","description":"The HTTP status code of the operation."},"messages":{"type":"array","description":"A list of error messages.\n","items":{"type":"object","properties":{"errorCode":{"type":"string","description":"Application internal error code\n"},"message":{"type":"string","description":"A human readable explanation specific to this occurrence of the\nproblem.\n"}}}}}}},"responses":{"BadRequest":{"description":"### Bad Request\nThe request send to the API was malformed.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"Unauthorized":{"description":"### Unauthorized\nThe request is missing authorization information or the authorization information provided are expired.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"NotAllowed":{"description":"### Not Allowed\nThe user issuing the request does not have the needed permissions.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"NotFound":{"description":"### Not Found\nThe resource that was requested could not be found.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"TooManyRequests":{"description":"### Too Many Requests\nThe user has sent too many requests in a given amount of time.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"InternalError":{"description":"### Internal Server Error\nAn internal error occurred. We apologize for the inconvenience!\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"ServiceUnavailable":{"description":"### Service Unavailable\nThe server is currently unable to handle the request due to a temporary overloading or maintenance of the server.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"UnexpectedError":{"description":"### Unexpected Internal Server Error\nAn unexpected internal error occurred. We apologize for the inconvenience!\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}},"paths":{"/certificates/{certificateId}":{"get":{"operationId":"certificatesFindById","summary":"Retrieve Certificate","tags":["Certificate"],"description":"Returns the Certificate by ID.","parameters":[{"name":"certificateId","in":"path","schema":{"type":"string","format":"uuid"},"required":true,"description":"The ID (UUID) of the Certificate."}],"responses":{"200":{"description":"Getting Certificate was successful.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/CertificateRead"}}}},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/NotAllowed"},"404":{"$ref":"#/components/responses/NotFound"},"429":{"$ref":"#/components/responses/TooManyRequests"},"500":{"$ref":"#/components/responses/InternalError"},"503":{"$ref":"#/components/responses/ServiceUnavailable"},"default":{"$ref":"#/components/responses/UnexpectedError"}}}}}}
```

## Delete Certificate

> Deletes the specified Certificate.

```json
{"openapi":"3.0.3","info":{"title":"Certificate Manager Service API","version":"2.0"},"tags":[{"name":"Certificate","description":"TLS/SSL certificates are used to secure network communications and prove\nthe identity of websites on the Internet and resources on private networks. The certificates and their associated\nprivate keys are provided in PEM (Privacy Enhanced Mail) format.\n\nThis tag groups all operations for certificate.\n"}],"servers":[{"url":"https://certificate-manager.de-fra.ionos.com","description":"Frankfurt"}],"security":[{"tokenAuth":[]}],"components":{"securitySchemes":{"tokenAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT","description":"The token can be generated using the \n[Authentication API](https://api.ionos.com/docs/authentication/v1/#tag/tokens/operation/tokensGenerate).\n"}},"responses":{"BadRequest":{"description":"### Bad Request\nThe request send to the API was malformed.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"Unauthorized":{"description":"### Unauthorized\nThe request is missing authorization information or the authorization information provided are expired.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"NotAllowed":{"description":"### Not Allowed\nThe user issuing the request does not have the needed permissions.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"NotFound":{"description":"### Not Found\nThe resource that was requested could not be found.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"TooManyRequests":{"description":"### Too Many Requests\nThe user has sent too many requests in a given amount of time.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"InternalError":{"description":"### Internal Server Error\nAn internal error occurred. We apologize for the inconvenience!\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"ServiceUnavailable":{"description":"### Service Unavailable\nThe server is currently unable to handle the request due to a temporary overloading or maintenance of the server.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"UnexpectedError":{"description":"### Unexpected Internal Server Error\nAn unexpected internal error occurred. We apologize for the inconvenience!\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}},"schemas":{"Error":{"description":"The Error object is used to represent an error response from the API.\n","type":"object","properties":{"httpStatus":{"type":"integer","description":"The HTTP status code of the operation."},"messages":{"type":"array","description":"A list of error messages.\n","items":{"type":"object","properties":{"errorCode":{"type":"string","description":"Application internal error code\n"},"message":{"type":"string","description":"A human readable explanation specific to this occurrence of the\nproblem.\n"}}}}}}}},"paths":{"/certificates/{certificateId}":{"delete":{"operationId":"certificatesDelete","summary":"Delete Certificate","tags":["Certificate"],"description":"Deletes the specified Certificate.","parameters":[{"name":"certificateId","in":"path","schema":{"type":"string","format":"uuid"},"required":true,"description":"The ID (UUID) of the Certificate."}],"responses":{"202":{"description":"Deleting Certificate was successful."},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/NotAllowed"},"404":{"$ref":"#/components/responses/NotFound"},"429":{"$ref":"#/components/responses/TooManyRequests"},"500":{"$ref":"#/components/responses/InternalError"},"503":{"$ref":"#/components/responses/ServiceUnavailable"},"default":{"$ref":"#/components/responses/UnexpectedError"}}}}}}
```

## Updates Certificate

> Changes Certificate with the provided ID.\
> Values provides will replace the existing data.<br>

```json
{"openapi":"3.0.3","info":{"title":"Certificate Manager Service API","version":"2.0"},"tags":[{"name":"Certificate","description":"TLS/SSL certificates are used to secure network communications and prove\nthe identity of websites on the Internet and resources on private networks. The certificates and their associated\nprivate keys are provided in PEM (Privacy Enhanced Mail) format.\n\nThis tag groups all operations for certificate.\n"}],"servers":[{"url":"https://certificate-manager.de-fra.ionos.com","description":"Frankfurt"}],"security":[{"tokenAuth":[]}],"components":{"securitySchemes":{"tokenAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT","description":"The token can be generated using the \n[Authentication API](https://api.ionos.com/docs/authentication/v1/#tag/tokens/operation/tokensGenerate).\n"}},"schemas":{"CertificatePatch":{"type":"object","required":["properties"],"properties":{"metadata":{"description":"Metadata","additionalProperties":true},"properties":{"$ref":"#/components/schemas/PatchName"}}},"PatchName":{"required":["name"],"properties":{"name":{"type":"string","description":"The new name."}}},"CertificateRead":{"type":"object","required":["id","type","href","metadata","properties"],"properties":{"id":{"type":"string","description":"The ID (UUID) of the Certificate.","format":"uuid"},"type":{"description":"The type of the resource.","type":"string","enum":["certificate"]},"href":{"description":"The URL of the Certificate.","type":"string"},"metadata":{"$ref":"#/components/schemas/MetadataWithCertificateInformation"},"properties":{"$ref":"#/components/schemas/Certificate"}}},"MetadataWithCertificateInformation":{"allOf":[{"$ref":"#/components/schemas/MetadataWithStatus"},{"type":"object","required":["expired","notBefore","notAfter","serialNumber","commonName","subjectAlternativeNames"],"properties":{"autoCertificate":{"type":"string","format":"uuid","description":"The ID of the auto-certificate that caused issuing of the certificate."},"lastIssuedCertificate":{"type":"string","format":"uuid","description":"The ID of the last issued certificate that belongs to the same auto-certificate."},"expired":{"type":"boolean","description":"Indicates if the certificate is expired."},"notBefore":{"type":"string","format":"date-time","description":"The start date of the certificate."},"notAfter":{"type":"string","format":"date-time","description":"The end date of the certificate."},"serialNumber":{"type":"string","description":"The serial number of the certificate in hex."},"commonName":{"type":"string","description":"The common name (DNS) of the certificate."},"subjectAlternativeNames":{"type":"array","items":{"type":"string"},"description":"Optional additional names added to the issued certificate.\nThe additional names needs to be part of a zone in IONOS Cloud DNS.\n"}}}]},"MetadataWithStatus":{"readOnly":true,"allOf":[{"$ref":"#/components/schemas/Metadata"},{"type":"object","required":["state","message"],"properties":{"state":{"type":"string","description":"The resource state.","enum":["PROVISIONING","AVAILABLE","FAILED"]},"message":{"type":"string","description":"A human readable message describing the current state.\nIn case of an error, the message will contain a detailed error message.\n"}}}]},"Metadata":{"type":"object","description":"Metadata of the resource.","properties":{"createdDate":{"type":"string","format":"date-time","description":"The ISO 8601 creation timestamp.","readOnly":true},"createdBy":{"type":"string","description":"Unique name of the identity that created the resource.","readOnly":true},"createdByUserId":{"type":"string","description":"Unique id of the identity that created the resource.","readOnly":true},"lastModifiedDate":{"type":"string","format":"date-time","description":"The ISO 8601 modified timestamp.","readOnly":true},"lastModifiedBy":{"type":"string","description":"Unique name of the identity that last modified the resource.","readOnly":true},"lastModifiedByUserId":{"type":"string","description":"Unique id of the identity that last modified the resource.","readOnly":true},"resourceURN":{"type":"string","description":"Unique name of the resource.","readOnly":true}}},"Certificate":{"description":"TLS/SSL certificates are used to secure network communications and prove\nthe identity of websites on the Internet and resources on private networks. The certificates and their associated\nprivate keys are provided in PEM (Privacy Enhanced Mail) format.\n","type":"object","required":["name","certificate","certificateChain","privateKey"],"properties":{"name":{"type":"string","description":"The certificate name."},"certificate":{"type":"string","description":"The certificate body."},"certificateChain":{"type":"string","description":"The certificate chain."},"privateKey":{"type":"string","description":"The RSA private key is used for authentication and symmetric key exchange when establishing an SSL session. It is a part of the public key infrastructure generally used with SSL certificates.","writeOnly":true}}},"Error":{"description":"The Error object is used to represent an error response from the API.\n","type":"object","properties":{"httpStatus":{"type":"integer","description":"The HTTP status code of the operation."},"messages":{"type":"array","description":"A list of error messages.\n","items":{"type":"object","properties":{"errorCode":{"type":"string","description":"Application internal error code\n"},"message":{"type":"string","description":"A human readable explanation specific to this occurrence of the\nproblem.\n"}}}}}}},"responses":{"BadRequest":{"description":"### Bad Request\nThe request send to the API was malformed.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"Unauthorized":{"description":"### Unauthorized\nThe request is missing authorization information or the authorization information provided are expired.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"NotAllowed":{"description":"### Not Allowed\nThe user issuing the request does not have the needed permissions.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"NotFound":{"description":"### Not Found\nThe resource that was requested could not be found.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"Conflict":{"description":"### Conflict\nThe UUID is already taken by another party, follow the guides to generate UUIDs uniquely.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"UnsupportedMediaType":{"description":"### Unsupported Media Type\nThe request has an unsupported media type.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"UnprocessableEntity":{"description":"### Unprocessable Entity\nThe request was well-formed but was unable to be followed due to semantic errors.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"TooManyRequests":{"description":"### Too Many Requests\nThe user has sent too many requests in a given amount of time.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"InternalError":{"description":"### Internal Server Error\nAn internal error occurred. We apologize for the inconvenience!\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"ServiceUnavailable":{"description":"### Service Unavailable\nThe server is currently unable to handle the request due to a temporary overloading or maintenance of the server.\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"UnexpectedError":{"description":"### Unexpected Internal Server Error\nAn unexpected internal error occurred. We apologize for the inconvenience!\n","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}}}},"paths":{"/certificates/{certificateId}":{"patch":{"operationId":"certificatesPatch","summary":"Updates Certificate","tags":["Certificate"],"description":"Changes Certificate with the provided ID.\nValues provides will replace the existing data.\n","parameters":[{"name":"certificateId","in":"path","schema":{"type":"string","format":"uuid"},"required":true,"description":"The ID (UUID) of the Certificate."}],"requestBody":{"description":"patch Certificate","required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/CertificatePatch"}}}},"responses":{"200":{"description":"Certificate successfully updated.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/CertificateRead"}}}},"400":{"$ref":"#/components/responses/BadRequest"},"401":{"$ref":"#/components/responses/Unauthorized"},"403":{"$ref":"#/components/responses/NotAllowed"},"404":{"$ref":"#/components/responses/NotFound"},"409":{"$ref":"#/components/responses/Conflict"},"415":{"$ref":"#/components/responses/UnsupportedMediaType"},"422":{"$ref":"#/components/responses/UnprocessableEntity"},"429":{"$ref":"#/components/responses/TooManyRequests"},"500":{"$ref":"#/components/responses/InternalError"},"503":{"$ref":"#/components/responses/ServiceUnavailable"},"default":{"$ref":"#/components/responses/UnexpectedError"}}}}}}
```
